@echo off

SET Reg_Macromedia=HKEY_LOCAL_MACHINE\SOFTWARE\Macromedia
SET Reg_Macromedia_X86=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Macromedia
SET Reg_FlashPlayerActiveX=HKEY_LOCAL_MACHINE\SOFTWARE\Macromedia\FlashPlayerActiveX
SET Reg_FlashPlayerActiveX_X86=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Macromedia\FlashPlayerActiveX

SET Path_Macromedia_Backup=C:\Macromedia_BK
SET FlashPlayerActiveX_Version=32.0.0.101

SET Flg_MacromediaExist_X64=1
SET Flg_MacromediaExist_X86=1

rem FlashPlayerActiveX backup folder
RMDIR /s /q %Path_Macromedia_Backup%
MKDIR %Path_Macromedia_Backup%

if "%PROCESSOR_ARCHITECTURE%" EQU "AMD64" goto :ARCH_X64
if "%PROCESSOR_ARCHITECTURE%" EQU "x86"   goto :ARCH_X86
echo unsupported environment & goto:EOF

:ARCH_X64
echo 64bit environment

reg query %Reg_Macromedia%
if %ERRORLEVEL% equ 1 (
  echo no key > %Path_Macromedia_Backup%\NotExistKey_X64
  SET Flg_MacromediaExist_X64=0
)

reg query %Reg_Macromedia_X86%
if %ERRORLEVEL% equ 1 (
  echo no key > %Path_Macromedia_Backup%\NotExistKey_X86
  SET Flg_MacromediaExist_X86=0
)

rem output current version
if %Flg_MacromediaExist_X64% equ 1 (
  reg query %Reg_FlashPlayerActiveX% /v "Version" > %Path_Macromedia_Backup%\FlashPlayerActiveX_Version_X64.txt
)
if %Flg_MacromediaExist_X86% equ 1 (
  reg query %Reg_FlashPlayerActiveX_X86% /v "Version" > %Path_Macromedia_Backup%\FlashPlayerActiveX_Version_X86.txt
)

rem Macromedia registry backup
if %Flg_MacromediaExist_X64% equ 1 (
  reg save %Reg_Macromedia% %Path_Macromedia_Backup%\Macromedia_X64.hiv /y
)
if %Flg_MacromediaExist_X86% equ 1 (
  reg save %Reg_Macromedia_X86% %Path_Macromedia_Backup%\Macromedia_X86.hiv /y
)

rem add version value
reg add %Reg_FlashPlayerActiveX% /v Version /t REG_SZ /d %FlashPlayerActiveX_Version% /f
reg add %Reg_FlashPlayerActiveX_X86% /v Version /t REG_SZ /d %FlashPlayerActiveX_Version% /f

goto :EOF


:ARCH_X86
echo 32bit environment

reg query %Reg_Macromedia%
if %ERRORLEVEL% equ 1 (
  echo no key > %Path_Macromedia_Backup%\NotExistKey_X86
  SET Flg_MacromediaExist_X86=0
)

rem output current version
if %Flg_MacromediaExist_X86% equ 1 (
  reg query %Reg_FlashPlayerActiveX% /v "Version" > %Path_Macromedia_Backup%\FlashPlayerActiveX_Version_X86.txt
)

rem Macromedia registry backup
if %Flg_MacromediaExist_X86% equ 1 (
  reg save %Reg_Macromedia% %Path_Macromedia_Backup%\Macromedia_X86.hiv /y
)

rem add version value
reg add %Reg_FlashPlayerActiveX% /v Version /t REG_SZ /d %FlashPlayerActiveX_Version% /f

goto :EOF
